#!/usr/bin/python

#  debdiff version 0.1

#  This program makes a delta between two Debian packages.
#
#  The delta is stored as an ar file with the following components:
#
# debian-diff    -- the 'magic number', it contains the value
#                  '2.0.patch-<debdiff-ver>>'
# control.tar.gz -- the control file of the new Debian package (includes a
#                  Patches: header)
# data.tar.gz    -- any files which should be put into the new archive
#                  without being changed.  In the same format as the
#                  data.tar.gz member of a Debian package.
# delta.tar.gz   -- a collection of patches made using 'xdelta'.  Stored
#                  like data.tar.gz -- that is, in a hierarchy corresponding
#                  to where they will go in the filesystem.  So usr/doc/foo
#                  is a patch for usr/doc/foo.

import os
import sys
import debfile
import string

def show_usage(file):
    file.write('Usage: %s [from-file] [to-file]\n'%os.path.basename(sys.argv[0]))

if os.getuid() <> 0:
    sys.stderr.write('%s: you must either run this program as root or use a program such\nas fakeroot (recommended)\n'%os.path.basename(sys.argv[0]))
    sys.exit(-1)

if len(sys.argv) != 3:
    sys.stderr.write('%s: wrong number of arguments\n'%os.path.basename(sys.argv[0]))
    show_usage(sys.stderr)
    sys.exit(-1)

fromfile=debfile.debfile(sys.argv[1])
tofile=debfile.debfile(sys.argv[2])

debfile.builddiff(fromfile,tofile)
