#!/usr/bin/python

#  This program applies a patch, either to a given .deb file or to one
# already on the system.

import os
import sys
import debfile

def show_usage(file):
    file.write('Usage: %s [patch-file] [package-to-patch]\n'%os.path.basename(sys.argv[0]))
    file.write('\n')
    file.write('  The new archive and reverse patch will be generated in the current directory')

if os.getuid() <> 0:
    sys.stderr.write('%s: you must either run this program as root or use a program such\nas fakeroot (recommended)\n'%os.path.basename(sys.argv[0]))
    sys.exit(-1)

if len(sys.argv) <> 3:
    sys.stderr.write('%s: wrong number of arguments'%os.path.basename(sys.argv[0]))
    show_usage(sys.stderr)
    sys.exit(-1)

patchfile=debfile.debdiff(sys.argv[1])
packagefile=None
cleanup=0

if os.path.isfile(sys.argv[2]):
    try:
	packagefile=debfile.debfile(sys.argv[2])
    except:
	pass

if not packagefile:
    import tempfile
    packagefile=debfile.rebuild(sys.argv[2],tempfile.mktemp())
    cleanup=1

try:
    (debfile,reverse)=patchfile.apply(packagefile)
    print "Created package file: %s"%debfile.filename
    print "Created reverse patch: %s"%reverse.filename
finally:
    if cleanup:
	os.remove(packagefile.filename)
